<?php

class DnetwoBot_Api {

	public static function get_bots( $client_id, $private_key ) {
		$private_key = self::prepare_private_key( $private_key );
		$token = self::get_token( $client_id, $private_key );

		$ch = curl_init();

		curl_setopt( $ch, CURLOPT_URL, DNETWO_BOT_API_URL );
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
		curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, true );
		curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false );
		curl_setopt( $ch, CURLOPT_SSL_VERIFYHOST, false );
		curl_setopt( $ch, CURLOPT_PORT, 443 );
		curl_setopt( $ch, CURLOPT_HTTPHEADER, array(
			'Content-type: application/json',
			"token: $token",
			"client-id: $client_id",
		) );

		$bots = curl_exec( $ch );

		curl_close( $ch );

		return $bots ? json_decode( $bots ) : false;
	}

	private static function prepare_private_key( $private_key ) {
		return preg_replace( '/\r/', '', $private_key );
	}

	private static function get_token( $client_id, $private_key ) {
		require_once( DNETWO_BOT_PLUGIN_DIR . 'libs/php-jwt/JWT.php' );

		$issuedAt = time();
		$expire   = $issuedAt + 60;

		$token = array(
			'clientId' => $client_id,
			'iat'      => $issuedAt,
			'exp'      => $expire,
		);

		return \Firebase\JWT\JWT::encode( $token, $private_key );
	}
}
