<?php

class DnetwoBot_Model {

	public static function get_bots( $customer_id ) {
		global $wpdb;

		$table_name = $wpdb->prefix . DNETWO_BOT_TABLE_NAME;

		$sql = "SELECT * FROM `{$table_name}` WHERE customer_id = '%s'";
		$sql = $wpdb->prepare( $sql, $customer_id );

		return $wpdb->get_results( $sql );
	}

	public static function get_frontend_bot( $customer_id, $page_id ) {
		$bots = self::get_bots( $customer_id );

		foreach ( $bots as $bot ) {
			$page_ids = explode( ', ', $bot->page_ids );

			if ( is_array( $page_ids ) && in_array( $page_id, $page_ids ) && $bot->active ) {
				return $bot;
			}
		}

		return false;
	}

	public static function sync_bots( $customer_id, $private_key ) {
		$bots = DnetwoBot_Api::get_bots( $customer_id, $private_key );

		if ( ! is_array( $bots ) ) {
			return false;
		}

		global $wpdb;

		$table_name = $wpdb->prefix . DNETWO_BOT_TABLE_NAME;

		foreach ( $bots as $bot ) {
			$sql = "INSERT INTO `{$table_name}` (customer_id, bot_key, bot_name, bot_link) VALUES (%s, %s, %s, %s) ON DUPLICATE KEY UPDATE bot_key = %s";
			$sql = $wpdb->prepare( $sql, $customer_id, $bot->key, $bot->name, $bot->botlink, $bot->key );

			$wpdb->query($sql);
		}

		self::delete_unused_bots( $customer_id, $bots );

		return true;
	}

	private static function delete_unused_bots( $customer_id, $api_bots ) {
		$bots = self::get_bots( $customer_id );

		foreach ( $bots as $bot ) {
			$delete = true;

			foreach ( $api_bots as $api_bot ) {
				if ( $bot->bot_key == $api_bot->key ) {
					$delete = false;
				}
			}

			if ( $delete ) {
				self::delete_bot( $bot->id );
			}
		}

		return true;
	}

	public static function delete_bot( $bot_id ) {
		global $wpdb;

		$table_name = $wpdb->prefix . DNETWO_BOT_TABLE_NAME;

		$sql = "DELETE FROM `{$table_name}` WHERE id = %d";
		$sql = $wpdb->prepare( $sql, $bot_id );

		return $wpdb->query($sql);
	}

	public static function update_bot( $bot_id, $data ) {
		global $wpdb;

		$table_name = $wpdb->prefix . DNETWO_BOT_TABLE_NAME;

		$sql = "UPDATE `{$table_name}` SET page_ids = %s, active = %d WHERE id = %d";
		$sql = $wpdb->prepare( $sql, $data['page_ids'], $data['active'], $bot_id );

		return $wpdb->query($sql);
	}

	public static function page_id_in_bot_pages_ids( $page_id, $bot_pages_ids ) {
		$bot_pages_ids = explode( ', ', $bot_pages_ids );

		return in_array( $page_id, $bot_pages_ids );
	}

	public static function prepare_bot_src( $bot_link ) {
		return str_replace( 'home', 'chat', $bot_link );
	}
}
