<?php
/*
Plugin Name: dnetwo.bot
Plugin URI: https://wordpress.org/plugins/dnetwo-bot/
Description: dnetwo.bot plugin is the easiest way to add a chat pop-up to your site. Let dnetwo.bot answer the incoming queries, allowing your support team to focus on the essentials and complex queries.
Version: 1.0.0
Author: dnetwo
Author URI: https://profiles.wordpress.org/dnetwo/
License: GPLv2 or later
Text Domain: dnetwo-bot
*/

// Make sure we don't expose any info if called directly
if ( ! function_exists( 'add_action' ) ) {
	echo 'Hi there!  I\'m just a plugin, not much I can do when called directly.';
	exit;
}

define( 'DNETWO_BOT_VERSION', '1.0.0' );
define( 'DNETWO_BOT_MINIMUM_WP_VERSION', '4.0' );
define( 'DNETWO_BOT_PLUGIN_DIR', plugin_dir_path( __FILE__ ) );
define( 'DNETWO_BOT_PLUGIN_URL', plugin_dir_url( __FILE__ ) );

if ( ! defined( 'ABSPATH' ) ) {
	define( 'ABSPATH', dirname( __FILE__ ) );
}

if ( ! defined( 'DNETWO_BOT_WPROOTPATH' ) ) {
	define( 'DNETWO_BOT_WPROOTPATH', str_replace( '\\', '/', ABSPATH ) );
}

define( 'DNETWO_BOT_API_URL', 'https://app.iox.bot/api/v2/bots/wordpress/' );
define( 'DNETWO_BOT_LOGIN_URL', 'https://app.iox.bot/login/' );
define( 'DNETWO_BOT_EDIT_URL', 'https://app.iox.bot/edit/' );
define( 'DNETWO_BOT_UPGRADE_URL', 'https://dnetwo.de/dnetwo-bot-upgrade/' );
define( 'DNETWO_BOT_TABLE_NAME', 'dnetwo_bots' );

register_activation_hook( __FILE__, array( 'DnetwoBot', 'plugin_activation' ) );
register_deactivation_hook( __FILE__, array( 'DnetwoBot', 'plugin_deactivation' ) );

require_once( DNETWO_BOT_PLUGIN_DIR . 'class.dnetwo-bot.php' );

add_action( 'init', array( 'DnetwoBot', 'init' ) );

if ( is_admin() || ( defined( 'WP_CLI' ) && WP_CLI ) ) {
	require_once( DNETWO_BOT_PLUGIN_DIR . 'class.dnetwo-bot-admin.php' );
	add_action( 'init', array( 'DnetwoBot_Admin', 'init' ) );
}

require_once( DNETWO_BOT_PLUGIN_DIR . 'class.dnetwo-bot-helper.php' );
require_once( DNETWO_BOT_PLUGIN_DIR . 'class.dnetwo-bot-api.php' );
require_once( DNETWO_BOT_PLUGIN_DIR . 'class.dnetwo-bot-model.php' );
